routes/admin.php
<?php

/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register admin-level routes. Routes in this file
| are protected by auth/login requirements.
|
*/

Route::middleware('admin')->namespace('Admin')->group(function () {

    /**
     * Admin-level homepage/dashboard.
     */
    Route::get('/', 'HomeController@index')->name('home');

    // Testimonials Route
    Route::resource('testimonials', 'TestimonialController');


    // Contact Route
    Route::resource('contacts', 'ContactController');

// setting route
    Route::get('settings' , 'SettingController@index')->name('settings.edit');

    Route::post('settings', 'SettingController@store')->name('settings.store');

    // new fabrication pages
//    Route::get('page/fabrication/list' , 'PageController@listFabrication')->name('fabrication.list');

    Route::resource('fabrications', 'FabricationController');

// slider Route
    Route::resource('sliders', 'SliderController');


    // slide Route
    Route::resource('slides', 'SlideController');

    // floorplan route
    Route::resource('floorplans', 'FloorPlanController');

    Route::post('floorplans/add-items', 'FloorPlanController@addItems');

    // coach model route
    Route::get('models', 'HomeController@models');
    Route::get('models/edit/{id}', 'HomeController@editModel');
    Route::post('models/update/{id}', 'HomeController@updateModel');

    // page route
    Route::get('page/{page}/{tab?}', 'PageController@index');

    Route::post('page/update', 'PageController@update');

    Route::post('page/content/{page}/{key}/delete', 'PageController@deleteContent');

    Route::post('page/content/{page}/{key}/{tab?}/delete', 'PageController@deleteContent');

    // custom reference categories routes
    Route:Route::resource('custom-reference-categories', 'CustomReferenceCategoryController');
    // custom post routes
    Route::get('/custom-posts','CustomPostController@index')->name('customposts.index');

    Route::Post('/custom-posts/slug','CustomPostController@slug')->name('customposts.slug');
    Route::get('/custom-post/create','CustomPostController@create')->name('customposts.create');

    Route::post('/custom-post/store','CustomPostController@store')->name('customposts.store');

    Route::get('/cutom-post/{id}/edit','CustomPostController@edit')->name('customposts.edit');

    Route::post('/custom-post/{id}/update','CustomPostController@update')->name('customposts.update');

    Route::delete('/custom-post/{id}/delete','CustomPostController@delete')->name('customposts.delete');

    Route::get('/custom-reference-category','MegaController@customReferenceCategory')->name('custom-reference-attribute.index');

    Route::get('/custom-reference-category/{id}/edit','MegaController@editCustomReferenceCategory')->name('custom-reference-attribute.edit');

    Route::post('/custom-reference-category/{id}/update','MegaController@updateCustomReferenceCategory')->name('custom-reference-attribute.update');

    /**
     * Users
     */
    //    Route::get('users/{user}/delete', 'UserController@delete')->name('users.delete');
    Route::resource('users', 'UserController');
    Route::resource('members', 'MemberController');
    Route::resource('virtual-tour', 'VirtualTourController'); // ***
//    Route::resource('service-specials', 'ServiceSpecialsController'); // ***
    Route::get('tour-event/payments', 'MemberController@paymentHistory');

    Route::get('{customPostSlug}', 'MegaController@index');
    Route::get('{customPostSlug}/create', 'MegaController@create');
    Route::post('{customPostSlug}/store', 'MegaController@store');
    Route::get('{customPostSlug}/{itemId}/edit', 'MegaController@edit');
    Route::put('{customPostSlug}/{itemId}/update', 'MegaController@update');
    Route::delete('{customPostId}/{itemId}/destroy', 'MegaController@delete');
    Route::post('{customPostId}/{itemId}/{sectionId}/{attributeId}/delete', 'MegaController@deleteDocument');
    Route::get('reference-data-by-selection/{selectedId}/{tableReferencedBy?}/{foreignKey?}', 'MegaController@getReferenceData');
    Route::post('update-sorting-order', 'MegaController@updateSortOrder');

    Route::resource('custom-attributes', 'CustomAttributeController');

});

routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//
//Route::get('/', function () {
//    return view('welcome');
//});

use App\Mail\NotificationSend;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;

Auth::routes();

Route::get('/', 'HomeController@index')->name('home');
Route::get('/about', 'HomeController@about')->name('about');
Route::get('/model/{coach?}', 'HomeController@models')->name('coach-model');
Route::get('/inventory', 'HomeController@inventory')->name('inventory');
Route::get('/motorcade-club', 'HomeController@motorcadeClub')->name('motorcade-club');
Route::get('/recall-information' , 'HomeController@recallInformation')->name('recall-information');
Route::get('/owner-service' , 'HomeController@ownerService')->name('owner-service');
Route::get('/technical-support', 'HomeController@technicalSupport')->name('technical-support');
//Route::get('/technical-support/search', 'HomeController@technicalSupportSearch')->name('technical-support-search');
Route::get('/information', 'HomeController@information')->name('information');
Route::get('/parts-department', 'HomeController@partsDepartment')->name('parts-department');
Route::get('/remodel-department', 'HomeController@remodelDepartment')->name('remodel-department');
Route::get('/service-department','HomeController@serviceDepartment')->name('service-department');
Route::get('/career','HomeController@career')->name('career');
Route::get('reference-data-by-selection/{selectedId}', 'HomeController@getReferenceData');
Route::get('fabrication/{page}', 'HomeController@getFabrication');

Route::post('/contact', 'HomeController@contactSubmit')->name('contact');

Route::post('/motorcade-member-register', 'Auth\RegisterController@motorcadeMemberRegister')->name('motorcade-member-register')->middleware('guest');
Route::get('/motorcade-member-profile', 'HomeController@motorcadeMemberProfile')->name('motorcade-member-profile');
Route::post('/motorcade-member-profile', 'HomeController@motorcadeMemberUpdate')->name('motorcade-member-update');
Route::get('/motorcade-member-directory/{type}', 'HomeController@motorcadeMemberDirectory')->name('motorcade-member-directory');

# PayPal checkout
Route::get('checkout', 'PaypalController@payWithPayPal')->name('checkout');

# PayPal status callback
Route::get('paypal-payment-status', 'PaypalController@getPaymentStatus')->name('payment-status');


Route::get('send-mail', function (){

    // get the subject of notification email.
    $subject        = 'New Motorcade Member Registration!!';

    // get the body of notification email.
    $contentText    = Auth::user();

    Mail::to(env('MAIL_TO_ADDRESS'))->send(new NotificationSend('member-registration',$contentText, $subject));

});

app/Http/Controllers/Admin/MemberController.php
<?php

namespace App\Http\Controllers\Admin;


use App\Jobs\RegenerateMembersPDF;
use App\Models\MembersPaymentHistory;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Validation\Rule;
use App\Http\Controllers\Controller;
use PDF;

class MemberController extends Controller
{
    /**
     * List all Users.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $users = $members = User::where('role','motorcade-member')->get();
//        dispatch(new RegenerateMembersPDF());

        return view('admin.members.index', compact('users'));
    }

    /**
     * Show the form for creating a new User.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        // Return the view.
        return view('admin.members.create');
    }

    /**
     * Store a newly created User in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     *
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {


        // Validate.
        $this->validate($request, [
//            'first_name'            => 'required',
//            'last_name'             => 'required',
            'email'                 => 'nullable|email',
//            'address_line_1'        => 'required',
//            'city'                  => 'required',
//            'state'                 => 'required',
//            'zip'                   => 'required',
//            'coach_type'            => 'required',
//            'year_model'            => 'required',
//            'last_six_number_vin'   => 'required',
//            'complete_model_number' => 'required',
        ]);

        // Create the new user.
        User::create([
            'name'                  => $request->last_name . ', ' . $request->first_name . (isset($request->spouse_name) && $request->spouse_name !=""? ' & ' .$request->spouse_name : ''),
            'password'              => bcrypt('SECRET'),
            'first_name'            => $request->first_name,
            'last_name'             => $request->last_name,
            'email'                 => $request->email,
            'spouse_name'           => $request->spouse_name,
            'address_line_1'        => $request->address_line_1,
            'address_line_2'        => $request->address_line_2,
            'city'                  => $request->city,
            'state'                 => $request->state,
            'zip'                   => $request->zip,
            'phone_number'          => $request->phone_number,
            'cell_number'           => $request->cell_number,
            'birthday'              => $request->birthday,
            'spouse_birthday'       => $request->spouse_birthday,
            'anniversary'           => $request->anniversary,
            'coach_type'            => $request->coach_type,
            'purchase_date'         => $request->purchase_date,
            'purchase_form'         => $request->purchase_form,
            'year_model'            => $request->year_model,
            'last_six_number_vin'   => $request->last_six_number_vin,
            'complete_model_number' => $request->complete_model_number,
            'fmca_member'           => isset($request->fmca_member)? $request->fmca_member : 0,
            'fmca_number'           => $request->fmca_number,
            'club_number'           => $request->club_number,
            'is_paid'               => 1,
            'role'                  => 'motorcade-member'
        ]);

        // regenerating members pdf
//        dispatch(new RegenerateMembersPDF());
//        _regenerateMembershipDirectory();

        // Done.
        return redirect()->route('admin.members.index')->with('success', 'The member was created successfully.');
    }

    /**
     * Display details about the specified User.
     *
     * @param  \App\Models\User  $user
     *
     * @return \Illuminate\Http\Response
     */
    public function show(User $user)
    {
        // check role
        if (Auth::user()->role == 'user'){

            return view('admin.pages.error');
        }

    }

    /**
     * Show the form for editing the specified User.
     *
     * @param  \App\Models\User  $user
     *
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {

        $user = User::findOrFail($id);

        // Return the view.
        return view('admin.members.edit', compact('user'));
    }

    /**
     * Update the specified User in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\User  $user
     *
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, User $user)
    {
        // Validate.
        $this->validate($request, [
//            'first_name'            => 'required',
//            'last_name'             => 'required',
            'email'                 => 'nullable|email',
            'username'              => 'nullable|unique:users,username,'. $request->id,
            'password'              => 'nullable|min:6|confirmed',
            'password_confirmation' => 'nullable',
//            'address_line_1'        => 'required',
//            'city'                  => 'required',
//            'state'                 => 'required',
//            'zip'                   => 'required',
//            'coach_type'            => 'required',
//            'year_model'            => 'required',
//            'last_six_number_vin'   => 'required',
//            'complete_model_number' => 'required',
        ]);

        $user = User::findOrFail($request->id);

        // Also change their password, if necessary.
        if (!empty($request->password)) {
            $user->password = bcrypt($request->password);
        }

        // Save.
        $user->save();

        User::where('id', $user->id)
            ->update([
                'name'                  => $request->last_name . ', ' . $request->first_name . (isset($request->spouse_name) && $request->spouse_name !=""? ' & ' .$request->spouse_name : ''),
                'username'              => $request->username,
                'first_name'            => $request->first_name,
                'last_name'             => $request->last_name,
                'email'                 => $request->email,
                'spouse_name'           => $request->spouse_name,
                'address_line_1'        => $request->address_line_1,
                'address_line_2'        => $request->address_line_2,
                'city'                  => $request->city,
                'state'                 => $request->state,
                'zip'                   => $request->zip,
                'phone_number'          => $request->phone_number,
                'cell_number'           => $request->cell_number,
                'birthday'              => $request->birthday,
                'spouse_birthday'       => $request->spouse_birthday,
                'anniversary'           => $request->anniversary,
                'coach_type'            => $request->coach_type,
                'purchase_date'         => $request->purchase_date,
                'purchase_form'         => $request->purchase_form,
                'year_model'            => $request->year_model,
                'last_six_number_vin'   => $request->last_six_number_vin,
                'complete_model_number' => $request->complete_model_number,
                'fmca_member'           => isset($request->fmca_member)? $request->fmca_member : 0,
                'fmca_number'           => $request->fmca_number,
                'club_number'           => $request->club_number,
            ]);

        // regenerating members pdf
//        dispatch(new RegenerateMembersPDF());
//        _regenerateMembershipDirectory();

        // Done.
        return redirect()->route('admin.members.index')->with('success', 'The User was updated successfully.');
    }


    /**
     * Remove the specified User from storage.
     *
     * @param  \App\Models\User  $user
     *
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request, $id)
    {
        // Delete the user.
        $user = User::findOrFail($id);
        $user->delete();

//        _regenerateMembershipDirectory();

        // Done.
        return redirect()->route('admin.members.index')->with('success', 'The User was deleted successfully.');
    }

    /**
     * List all Members who paid for custom events.
     *
     * @return \Illuminate\Http\Response
     */
    public function paymentHistory(Request $request, $package = null)
    {

        $payments = MembersPaymentHistory::all();

        return view('admin.members.payments', compact('payments'));
    }


}

resources/views/admin/members/index.blade.php
@extends('layouts.admin')
@section('content')
    {!!  _breadcrumbs('Members')  !!}
<div class="">
    <div class="row">
        <div class="col-12">

            <div class="page-header">
                    <h1>
                        Members
                        <small>
                            <i class="ace-icon fa fa-angle-double-right"></i>
                            All Members
                        </small>
                    </h1>
            </div>

            <a href="{{ url('admin/members/create' . (isset($_GET['ref'])? ('?ref=' . $_GET['ref']) : '')) }}">
                <span class="btn btn-success create-button">Create</span>
            </a>

            @if (session('success'))
                <div class="alert alert-success">
                    <button type="button" class="close" data-dismiss="alert">
                        <i class="ace-icon fa fa-times"></i>
                    </button>

                    <strong>
                        <i class="ace-icon fa fa-check"></i>
                        Success!
                    </strong>
                    {{ session('success') }}
                    <br>
                </div>
            @endif


            <table id="dynamic-table" class="table table-striped table-bordered table-hover dynamic-table">
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Username</th>
                        <th>Email</th>
                        <th>Phone</th>
                        <th>Coach Type</th>
                        <th>Year Model</th>
                        {{--<th>Last Six Number of VIN</th>--}}
                        <th>Action</th>
                    </tr>
                </thead>

                <tbody>

                    @foreach($users as $user)

                    <tr>

                        <td>{{ $user->name }}</td>
                        <td>{{ $user->username }}</td>
                        <td>{{ $user->email }}</td>
                        <td>{{ $user->phone_number }}</td>
                        <td>{{ $user->coach_type }}</td>
                        <td>{{ $user->year_model }}</td>
                        <td>
                            <div class="hidden-sm hidden-xs btn-group" style="display:flex">
                                <a class="btn btn-xs btn-success" href="{{route('admin.members.edit', $user->id)}}">
                                    <i class="ace-icon fa fa-pencil bigger-120"></i>
                                </a>

                                <form method="post" class="delete_form" action="{{route('admin.members.destroy', $user->id)}}">
                                    {{csrf_field()}}
                                    <input type="hidden" name="_method" value="DELETE" />
                                    <button type="submit" onclick="return confirm('Are you sure?')" class="btn btn-xs btn-danger" class="tooltip-info" data-rel="tooltip" title="Delete">
                                        <span class="red">
                                            <i style="background-color:white" class="ace-icon fa fa-trash-o bigger-120"></i>
                                        </span>
                                    </button>
                                </form>
                            </div>
                        </td>
                    </tr>

                    @endforeach

                </tbody>
            </table>
        </div>
    </div>

</div>


@endsection

resources/views/admin/members/make_members_pdf.blade.php
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>Members Directory</title>
</head>
<body>
{{--<h1>Members Directory</h1>--}}

<table width="100%" style="width:100%;border-spacing: 0;font-size: 10px" border="0">
    <tr style="background-color: #7a9700">
        <th>Club #</th>
        <th>Name</th>
        <th>Address</th>
        <th>City</th>
        <th>St</th>
        <th>Zip</th>
        <th>Phone</th>
        <th>Email</th>
    </tr>


    @foreach($members as $member)
        <tr style="background-color: #9affa3">
            <td>{{ $member->club_number }}</td>
            <td>{{ $member->name }}</td>
            <td>{{ $member->address_line_1 }}</td>
            <td>{{ $member->city }}</td>
            <td>{{ $member->state }}</td>
            <td>{{ $member->zip }}</td>
            <td>{{ $member->phone_number }}</td>
            <td>{{ $member->email }}</td>
        </tr>
    @endforeach

</table>
</body>
</html>

resources/views/admin/members/payments.blade.php
@extends('layouts.admin')
@section('content')
    {!!  _breadcrumbs('Members')  !!}
<div class="">
    <div class="row">
        <div class="col-12">

            <div class="page-header">
                    <h1>
                        Members Payment History
                        <small>
                            <i class="ace-icon fa fa-angle-double-right"></i>
                            All Payments
                        </small>
                    </h1>
            </div>

            @if (session('success'))
                <div class="alert alert-success">
                    <button type="button" class="close" data-dismiss="alert">
                        <i class="ace-icon fa fa-times"></i>
                    </button>

                    <strong>
                        <i class="ace-icon fa fa-check"></i>
                        Success!
                    </strong>
                    {{ session('success') }}
                    <br>
                </div>
            @endif


            <table id="dynamic-table" class="table table-striped table-bordered table-hover dynamic-table">
                <thead>
                    <tr>
                        <th>Event Name</th>
                        <th>Member</th>
                        <th>Amount ($)</th>
                        <th>Paid At</th>
                        {{--<th>Action</th>--}}
                    </tr>
                </thead>

                <tbody>

                    @foreach($payments as $payment)

                    <tr>

                        <td>
                            <a href="{{route('admin.members.edit', $payment->user_id)}}">
                                {{ $payment->description }}
                            </a>
                        </td>
                        <td>{{ $payment->user->name }}</td>
                        <td>{{ $payment->amount }}</td>
                        <td>{{ date("d. M. Y H:i", strtotime($payment->created_at)) }}</td>
                        {{--<td>--}}
                            {{--<div class="hidden-sm hidden-xs btn-group" style="display:flex">--}}

                                {{--<form method="post" class="delete_form" action="{{route('admin.members.destroy', $user->id)}}">--}}
                                    {{--{{csrf_field()}}--}}
                                    {{--<input type="hidden" name="_method" value="DELETE" />--}}
                                    {{--<button type="submit" onclick="return confirm('Are you sure?')" class="btn btn-xs btn-danger" class="tooltip-info" data-rel="tooltip" title="Delete">--}}
                                        {{--<span class="red">--}}
                                            {{--<i style="background-color:white" class="ace-icon fa fa-trash-o bigger-120"></i>--}}
                                        {{--</span>--}}
                                    {{--</button>--}}
                                {{--</form>--}}
                            {{--</div>--}}
                        {{--</td>--}}
                    </tr>

                    @endforeach

                </tbody>
            </table>
        </div>
    </div>

</div>


@endsection